#pragma once
#include <memory>
#include <vector>

#include "lasp_mathtypes.h"
#include "lasp_types.h"

/**
 * \addtogroup dsp
 * @{
 */

/**
 * @brief Apply frequency domain smoothing to a Frequency domain (single
 * sided)signal power spectrum
 * 
 * @param freq Frequency range
 * @param X Signal pwr
 * @param w Parameter determining the smoothing with. 1 = 1/1 octave, 3 = 1/3th
 * octave and so on
 * @param power_correct Apply a correction to the whole spectrum to make the
 * signal power equal to the unsmoothed signal power.
 * @return vd Smoothed spectrum
 */
vd freqSmooth(const vd& freq, const vd& X, const unsigned w,
              bool power_correct = false);

/** @} */
